#include "postgres.h"
#include "utils/builtins.h"
#include "access/hash.h"

PG_MODULE_MAGIC;

PG_FUNCTION_INFO_V1(dummy_in);
PG_FUNCTION_INFO_V1(dummy_out);
PG_FUNCTION_INFO_V1(dummy_compare);
PG_FUNCTION_INFO_V1(hash_data);

/* input funtion */
Datum
dummy_in(PG_FUNCTION_ARGS)
{
	char     *input_text = PG_GETARG_CSTRING(0);    /* input plain text */
	Datum tmp = DirectFunctionCall1(textin,CStringGetDatum(input_text));

	PG_RETURN_DATUM(DirectFunctionCall1(textout,tmp));
}

/* output funtion */
Datum
dummy_out(PG_FUNCTION_ARGS)
{
	char     *input_text = PG_GETARG_CSTRING(0);    /* input plain text */
	Datum tmp = DirectFunctionCall1(textin,CStringGetDatum(input_text));

	PG_RETURN_DATUM(DirectFunctionCall1(textout,tmp));
}

/* = operator */
Datum
dummy_compare(PG_FUNCTION_ARGS)
{
	Datum input1 = PG_GETARG_DATUM(0);
	Datum input2 = PG_GETARG_DATUM(1);

	PG_RETURN_BOOL(input1 == input2);
}

/* hash funtion for OPERATOR CLASS */
Datum
hash_data(PG_FUNCTION_ARGS)
{
	struct varlena *hashkey = PG_GETARG_VARLENA_PP(0);

	Datum  result;

	result = hash_any((unsigned char *) VARDATA_ANY(hashkey),
					VARSIZE_ANY_EXHDR(hashkey));

	/* avoiding leaking memory for toasted input */
	PG_FREE_IF_COPY(hashkey, 0);

	return result;
}
