BEGIN;

	/* NOTE: Please change /home/postgres/grouping_sets_segv/ to your grouping_sets_segv source path */

	CREATE TYPE dummy_datatype;

	/* input function for dummy type */
	CREATE FUNCTION dummy_in(cstring)
	RETURNS dummy_datatype                                                        
		AS '/home/postgres/grouping_sets_segv/dummy_datatype.so','dummy_in'    
	LANGUAGE C IMMUTABLE STRICT;

	/* output function for dummy type */
	CREATE FUNCTION dummy_out(dummy_datatype)
	RETURNS cstring                                                               
		AS '/home/postgres/grouping_sets_segv/dummy_datatype.so','dummy_out'    
	LANGUAGE C IMMUTABLE STRICT;

	/* define dummy type */
	CREATE TYPE dummy_datatype (
		INPUT = dummy_in,                                                               
		OUTPUT = dummy_out                                                                                                     
	);

	/* function for = operator */
	CREATE FUNCTION dummy_compare(dummy_datatype,dummy_datatype)
	RETURNS bool                                                                    
		AS '/home/postgres/grouping_sets_segv/dummy_datatype.so','dummy_compare'
	LANGUAGE C IMMUTABLE STRICT;
	
	/* define = operator */
	CREATE OPERATOR = (
		leftarg = dummy_datatype, rightarg = dummy_datatype, procedure = dummy_compare);

	/* Function for CREATE OPERATOR CLASS index */
	CREATE OR REPLACE FUNCTION
		hash_dummy(dummy_datatype)
	RETURNS
		integer	
	AS
		'/home/postgres/grouping_sets_segv/dummy_datatype.so','hash_data'
	LANGUAGE C STRICT IMMUTABLE;

	/* create HASH OPERATOR CLASS for dummy type */
	CREATE OPERATOR CLASS
		hash_dummy_ops
	DEFAULT FOR TYPE
		dummy_datatype
	USING
		hash
	AS
		OPERATOR                1          = (dummy_datatype,dummy_datatype),
		FUNCTION                1          hash_dummy(dummy_datatype);

COMMIT;
